<script setup lang="ts">
import axios from 'axios'
import { Bar } from 'vue-chartjs'
import {
  Chart as ChartJS,
  Title,
  Tooltip,
  Legend,
  BarElement,
  CategoryScale,
  LinearScale
} from 'chart.js'
import { onMounted, reactive, ref } from 'vue'

function gencolor(num: number) {
  const colors = []

  for (let i = 0; i < num; i++) {
    const randomColor = '#' + Math.floor(Math.random() * 16777215).toString(16)
    colors.push(randomColor)
  }
  return colors
}

async function getBuyStockGraph1() {
  const res = await axios.get('http://localhost:4000/buystock-orders/getBuyStockGraph1')
  console.log(res)
  const labels = res.data.map((it: any) => {
    return it.stock_name
  })
  const data = res.data.map((it: any) => {
    return it.total_quantity
  })
  const colors = gencolor(labels.length)
  console.log(labels, data)
  chartData.value = {
    labels: labels,
    datasets: [
      {
        label: 'ยอดการสั่งซื้อ (ชิ้น)',
        backgroundColor: colors,
        data: data
      }
    ]
  }
}

onMounted(async () => {
  await getBuyStockGraph1()
})

ChartJS.register(Title, Tooltip, Legend, BarElement, CategoryScale, LinearScale)

const chartData = ref({
  labels: [],
  datasets: [
    {
      label: 'Data One',
      backgroundColor: '#f87979',
      data: []
    }
  ]
})
const chartOptions = ref({
  responsive: false,
  maintainAspectRatio: true
})
</script>

<template>
  <v-card style="background-color: white">
    <v-card-title style="font-size: 18px; font-weight: bold"
      >แสดงยอดการสั่งซื้อของเข้าสต็อก รายเดือน</v-card-title
    >
    <Bar id="my-chart-id" :options="chartOptions" :data="chartData" width="350" />
  </v-card>
</template>
